Index: arch/ia64/Makefile.inc
===================================================================
--- arch/ia64/Makefile.inc	(revision 30ef8ce93ca0f3eca4d4f65792495acb39b0db11)
+++ arch/ia64/Makefile.inc	(revision 2a0047fcb720d09f996a192519ef268a7c44731a)
@@ -17,3 +17,5 @@
 arch_sources= \
 	arch/start.S \
-	arch/fake.s
+	arch/fake.s \
+	arch/putchar.c \
+	arch/ia64.c
Index: arch/ia64/_link.ld
===================================================================
--- arch/ia64/_link.ld	(revision 30ef8ce93ca0f3eca4d4f65792495acb39b0db11)
+++ arch/ia64/_link.ld	(revision 2a0047fcb720d09f996a192519ef268a7c44731a)
@@ -3,5 +3,5 @@
 
 SECTIONS {
-    .image 0x8000000000000000: AT (0x8000000000000000) { 
+    .image 0x0000000000001000: AT (0x0000000000001000) { 
 	    *(.text .stub .text.* .gnu.linkonce.t.*)
 	    *(.interp)
Index: arch/ia64/boot/_link.ld
===================================================================
--- arch/ia64/boot/_link.ld	(revision 30ef8ce93ca0f3eca4d4f65792495acb39b0db11)
+++ arch/ia64/boot/_link.ld	(revision 2a0047fcb720d09f996a192519ef268a7c44731a)
@@ -3,5 +3,5 @@
 
 SECTIONS {
-    .image 0xf000000000000000: AT (0xf000000000000000) { 
+    .image 0x0000000000000000: AT (0x0000000000000000) { 
 	    *(.text .stub .text.* .gnu.linkonce.t.*)
 	    *(.interp)
Index: arch/ia64/boot/boot.s
===================================================================
--- arch/ia64/boot/boot.s	(revision 30ef8ce93ca0f3eca4d4f65792495acb39b0db11)
+++ arch/ia64/boot/boot.s	(revision 2a0047fcb720d09f996a192519ef268a7c44731a)
@@ -31,3 +31,3 @@
 .global start
 start:
-    brl -0x7000000000000000
+    brl 0x0000000001000000
Index: arch/ia64/include/ski/ski.h
===================================================================
--- arch/ia64/include/ski/ski.h	(revision 2a0047fcb720d09f996a192519ef268a7c44731a)
+++ arch/ia64/include/ski/ski.h	(revision 2a0047fcb720d09f996a192519ef268a7c44731a)
@@ -0,0 +1,35 @@
+/*
+ * Copyright (C) 2005 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef __SKI_H__
+#define __SKI_H__
+
+#define SKI_CONSOLE_INIT	20
+#define SKI_CONSOLE_PUTC	31
+	
+#endif
Index: arch/ia64/src/fake.s
===================================================================
--- arch/ia64/src/fake.s	(revision 30ef8ce93ca0f3eca4d4f65792495acb39b0db11)
+++ arch/ia64/src/fake.s	(revision 2a0047fcb720d09f996a192519ef268a7c44731a)
@@ -51,5 +51,4 @@
 .global memsetb
 .global panic
-.global putchar
 
 before_thread_runs:
@@ -75,5 +74,4 @@
 memsetb:
 panic:
-putchar:
-	brl 0x0
+	br.ret.sptk.many rp
 
Index: arch/ia64/src/ia64.c
===================================================================
--- arch/ia64/src/ia64.c	(revision 2a0047fcb720d09f996a192519ef268a7c44731a)
+++ arch/ia64/src/ia64.c	(revision 2a0047fcb720d09f996a192519ef268a7c44731a)
@@ -0,0 +1,28 @@
+/*
+ * Copyright (C) 2005 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
Index: arch/ia64/src/putchar.c
===================================================================
--- arch/ia64/src/putchar.c	(revision 2a0047fcb720d09f996a192519ef268a7c44731a)
+++ arch/ia64/src/putchar.c	(revision 2a0047fcb720d09f996a192519ef268a7c44731a)
@@ -0,0 +1,34 @@
+/*
+ * Copyright (C) 2005 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <putchar.h>
+#include <arch/types.h>
+
+void putchar(char ch)
+{
+}
Index: arch/ia64/src/start.S
===================================================================
--- arch/ia64/src/start.S	(revision 30ef8ce93ca0f3eca4d4f65792495acb39b0db11)
+++ arch/ia64/src/start.S	(revision 2a0047fcb720d09f996a192519ef268a7c44731a)
@@ -27,4 +27,6 @@
 #
 
+#include <arch/ski/ski.h>
+
 .text
 
@@ -32,3 +34,15 @@
 
 kernel_image_start:
-	brl 0x0
+	# initialize gp (Global Pointer) register
+	mov r1=0x1000
+
+	# initialize Ski console using SSC (Simulator System Sall)
+	mov r15=SKI_CONSOLE_INIT
+	break 0x80000
+
+0:
+	mov r15=SKI_CONSOLE_PUTC
+	mov r32='.'
+	break 0x80000
+
+	br 0b
